var bookWorker=
{
    OLAY: null,
    URLSTACK: new Array(),  
    MAXLEN:10, //add these many urls to stack in one go. var not used !
    //INCLUDEDYNAMIC : false, //true,
    TYPE_BOOKMARK : 1, //maps to nsINavBookmarksService.idl
    FLTR : new RegExp("^http"),
    livemarkService :null,
    
    
    //load random bookmarks from database to th stack
    //called by nextURL()
    getRandomBookmarks : function( )
    {
        
        if (this.URLSTACK.length > 0)
            {
                var url=this.URLSTACK.pop()  ;
                this.openURL(url);
                return;
            }
            
            
            //find places db file
            var file = Components.classes["@mozilla.org/file/directory_service;1"]
            .getService(Components.interfaces.nsIProperties)
            .get("ProfD", Components.interfaces.nsIFile);
            //alert("ProfD="+file.path);                
            file.append("places.sqlite");
            
            var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
            .getService(Components.interfaces.nsINavBookmarksService);
            var url=null;
            var uri=null;            
            
            //open connection to db            
            var storageService = Components.classes["@mozilla.org/storage/service;1"]
            .getService(Components.interfaces.mozIStorageService);
           //var mDBConn = storageService.openDatabase(file);


            var mDBConn=Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsPIPlacesDatabase).DBConnection;
            
            //prepare a statement
            var statement = mDBConn.createStatement("SELECT * FROM moz_bookmarks WHERE type = 1 ORDER BY  random() LIMIT 5");
            
            
            //Execute the statement and get values (rows)
            try{
                while (statement.executeStep()) {
                    var idVal = statement.getInt32(0); // let's get id's (1st col)only
                    var titleVal = statement.getString(5); // get title's (6th col)only
                    var parent=statement.getInt32(3); // get Parent folder
                    if ( !this.OLAY.INCLUDEDYNAMIC && this.checkLivemark(parent))
                        {
                            continue;
                        }
                        
                        //detour to url-finding
                        uri=bmsvc.getBookmarkURI(idVal);
                        url= (uri !=null)? uri.spec:"bad_uri";   
                        if (!this.FLTR.test(url))
                            continue;
                        
                        this.URLSTACK.push(url);
                    }//while
                }finally
                {
                    statement.reset(); //releaase lock
                    this.livemarkService=null;
                }  //finally           
                
                
            },//
            
    //check if it is dynamic bookmark
    checkLivemark : function (folder)
    {
        if (this.livemarkService==null)
            this.livemarkService = Components.classes["@mozilla.org/browser/livemark-service;2"]
        .getService(Components.interfaces.nsILivemarkService);

        return this.livemarkService.isLivemark(folder);

    },



    //get next url from the stack
    //This Is the ENTRY POINT
    nextURL: function(olay)
    {
        if   (this.OLAY==null) 
            {
                this.OLAY=olay;                        
            }


            if ( this.URLSTACK.length == 0)
                {
                    try{
                        this.getRandomBookmarks();
                    }catch ( ex)
                    {
                        alert (ex.message+ex.toString());

                        return null;
                    }//catch
                }     
                return this.URLSTACK.pop();             

            }


                    
                    
}//end object bookWorker